-- get the addon namespace
local addon, ns = ...

-- get the config values
local cfg = ns.cfg

-- get the library
local lib = ns.lib

lib.classes["DRUID"] = {}
local t,s
lib.classes["DRUID"][10] = function()
	lib.AddSpell("Wrath",{5176}) -- Wrath
	cfg.gcd = "Wrath"
	lib.AddSpell("Starfire",{2912}) -- Starfire
	lib.AddSpell("Moonfire",{8921}) -- Moonfire
	lib.AddSpell("Starsurge",{78674}) -- Starsurge
	lib.AddSpell("IS",{5570}) -- Insect Swarm
	lib.AddSpell("Inner",{29166}) -- Innervate
	
	lib.AddAura("Moonfire",8921,"debuff","target") -- Moonfire
	lib.AddAura("Sunfire",93402,"debuff","target") -- Sunfire
	lib.AddAura("IS",5570,"debuff","target") -- Moonfire
	lib.AddAura("Solar",48517,"buff","player") -- Solar
	lib.AddAura("SS",93400,"buff","player") -- Shooting Stars
	lib.AddAura("Lunar",48518,"buff","player") -- Lunar
	
	cfg.plistdps = {}
	table.insert(cfg.plistdps,"Starsurge_SS")
	table.insert(cfg.plistdps,"IS_noIS")
	table.insert(cfg.plistdps,"Moonfire_noMoonfire")
	table.insert(cfg.plistdps,"Starsurge")
	table.insert(cfg.plistdps,"Starfire")
	table.insert(cfg.plistdps,"Wrath")
	table.insert(cfg.plistdps,"Inner")
	table.insert(cfg.plistdps,"end")
	cfg.plist=cfg.plistdps
	
	cfg.case = {
		["Moonfire_noMoonfire"] = function ()
			if lib.GetAura({"Moonfire","Sunfire"})-lib.GetSpellCD(cfg.gcd)<2 then
				return lib.SimpleCDCheck("Moonfire")
			end
			return nil
		end,
		["IS_noIS"] = function ()
			if lib.GetAura({"IS"})-lib.GetSpellCD(cfg.gcd)<2 then
				return lib.SimpleCDCheck("IS")
			end
			return nil
		end,
		["Starsurge"] = function ()
			if not lib.SpellCasting("Starsurge") or lib.GetAura({"SS"})>0 then
				return lib.SimpleCDCheck("Starsurge")
			end
			return nil
		end,
		["Starsurge_SS"] = function ()
			if lib.GetAura({"SS"})>0 then
				return lib.SimpleCDCheck("Starsurge")
			end
			return nil
		end,
		["Wrath"] = function ()
			if lib.GetAura({"Solar"})>0 then 
				return lib.SimpleCDCheck("Wrath")
			elseif lib.GetAura({"Lunar"})==0 and cfg.eclipse<=0 then
				if cfg.eclipse>-85 then
					return lib.SimpleCDCheck("Wrath")
				elseif cfg.eclipse<=-85 and lib.SpellCasting("Starsurge") then
					return lib.SimpleCDCheck("Starfire")
				elseif cfg.eclipse<=-87 and lib.SpellCasting("Wrath") then
					return lib.SimpleCDCheck("Starfire")
				end
				return lib.SimpleCDCheck("Wrath")
			end
			return nil
		end,
		["Starfire"] = function ()
			if lib.GetAura({"Lunar"})>0 then
				return lib.SimpleCDCheck("Starfire")
			elseif lib.GetAura({"Solar"})==0 and cfg.eclipse>0 then
				if cfg.eclipse<80 then
					return lib.SimpleCDCheck("Starfire")
				elseif cfg.eclipse>=80 and lib.SpellCasting("Starfire") then
					return lib.SimpleCDCheck("Wrath")
				elseif cfg.eclipse>=85 and lib.SpellCasting("Starsurge") then
					return lib.SimpleCDCheck("Wrath")
				end
				return lib.SimpleCDCheck("Starfire")
			end
			return nil
		end,
	}
	
	lib.rangecheck=function()
		if lib.inrange("Wrath") then
			lib.bdcolor(Heddmain.bd,nil)
		else
			lib.bdcolor(Heddmain.bd,{1,0,0,1})
		end
	end
	
	cfg.eclipse=UnitPower('player', SPELL_POWER_ECLIPSE)
	
	lib.myonpower=function(unit,powerType)
		if unit=="player" and powerType == 'ECLIPSE' then
			cfg.eclipse=UnitPower('player', SPELL_POWER_ECLIPSE)
			cfg.Update=true
		end
	end
	return true
end

lib.classes["DRUID"][2] = function()
	lib.SetSpellIcon("aa","Interface\\Icons\\Ability_Druid_CatFormAttack",true)
	lib.SetPower("ENERGY")
	lib.SetAltPower("COMBO_POINTS")
	lib.AddSpell("Wrath",{5176}) -- Wrath
	cfg.gcd = "Wrath"
	cfg.set["T13"]={}
	cfg.set["T13"]={77013,77014,77015,77016,77017,78743,78665,78713,78694,78684,78838,78760,78808,78789,78779}
-- if cfg.shape=="Bear" then
	-- lib.AddSpell("Enrage",{5229}) -- Enrage
	-- lib.AddSpell("Thrash",{77758}) -- Thrash
	-- lib.AddSpell("Mangle",{33878}) -- Mangle
	-- lib.AddSpell("FF",{16857}) -- Faerie Fire (Feral)
	-- lib.AddSpell("Maul",{6807}) -- Maul
	-- lib.AddSpell("Swipe",{779}) -- Swipe
	-- lib.AddSpell("Demo",{99}) -- Demoralizing Roar
	-- lib.AddSpell("Lacerate",{33745}) -- Lacerate
	-- lib.AddSpell("Pulverize",{80313}) -- Pulverize
	
	-- lib.AddAura("Pulverize",80951,"buff","player") -- Pulverize
	-- lib.AddAura("Mangle",33878,"debuff","target") -- Mangle
	-- lib.AddAura("Lacerate",33745,"debuff","target") -- Lacerate

	
	-- lib.AddAuras("Demo",{1160,702,99,50256,24423,81130,26017},"debuff","target") -- Demo
	
	-- lib.AddAuras("FF",{91565,95466,7386,8647,95467},"debuff","target") -- FF
	
	-- cfg.plistdps = {}
	-- table.insert(cfg.plistdps,"FF_noFF")
	-- table.insert(cfg.plistdps,"Mangle")
	-- table.insert(cfg.plistdps,"Demo_noDemo")
	-- table.insert(cfg.plistdps,"Lacerate_noLacerate")
	-- table.insert(cfg.plistdps,"Thrash")
-- --	table.insert(cfg.plistdps,"Pulverize_Lacerate")
	-- table.insert(cfg.plistdps,"Pulverize_noPulverize")
	-- table.insert(cfg.plistdps,"Lacerate_no3Lacerate")
	-- table.insert(cfg.plistdps,"FF")
	-- table.insert(cfg.plistdps,"Lacerate")
	-- table.insert(cfg.plistdps,"Maul_single")
	-- table.insert(cfg.plistdps,"Enrage")
	-- table.insert(cfg.plistdps,"end")
	
	-- cfg.plistaoe = {}
	-- table.insert(cfg.plistaoe,"Thrash")
	-- table.insert(cfg.plistaoe,"Demo_noDemo")
	-- table.insert(cfg.plistaoe,"Swipe")
	-- table.insert(cfg.plistaoe,"Pulverize_noPulverize")
	-- table.insert(cfg.plistaoe,"Mangle")
	-- table.insert(cfg.plistaoe,"Lacerate")
	-- table.insert(cfg.plistaoe,"Maul_single")
-- --	table.insert(cfg.plistaoe,"FF")
-- --	table.insert(cfg.plistaoe,"Maul_aoe")
	-- table.insert(cfg.plistaoe,"Enrage")
	-- table.insert(cfg.plistaoe,"end")
	
	-- cfg.case = {
		-- ["Pulverize_noPulverize"] = function ()
			-- if lib.GetAuraStacks("Lacerate")>0 and not lib.GetLastSpell({"Pulverize"}) then
				-- return lib.SimpleCDCheck("Pulverize",lib.GetAura({"Pulverize"})-1)
			-- end
			-- return nil
		-- end,
		-- ["Lacerate_no3Lacerate"] = function()
			-- if lib.GetAuraStacks("Lacerate")<3 then
				-- return lib.SimpleCDCheck("Lacerate")
			-- end
		-- end,
		-- ["Lacerate_noLacerate"] = function()
			-- return lib.SimpleCDCheck("Lacerate",lib.GetAura({"Lacerate"})-1)
		-- end,
		-- ["Demo_noDemo"] = function()
			-- return lib.SimpleCDCheck("Demo",lib.GetAuras("Demo")-1)
		-- end,
		-- ["Enrage"] = function ()
			-- if cfg.Power.now<30 then
				-- return lib.SimpleCDCheck("Enrage")
			-- end
			-- return nil
		-- end,
		-- ["Maul_single"] = function ()
			-- if cfg.Power.now>=65 and lib.GetSpellCD(cfg.gcd)>0 then --!!! use while gcd is up!!!
				-- return lib.SimpleCDCheck("Maul")
			-- end
			-- return nil
		-- end,
		-- ["Pulverize_Lacerate"] = function ()
			-- if lib.GetAuraStacks("Lacerate")==3 and not lib.GetLastSpell({"Pulverize"}) then
				-- return lib.SimpleCDCheck("Pulverize",lib.GetAura({"Pulverize"})-1)
			-- end
			-- return nil
		-- end,
		-- ["Maul_aoe"] = function ()
			-- if cfg.Power.now>=45 and lib.GetSpellCD("Swipe")>lib.GetSpellCD(cfg.gcd) then
				-- return lib.SimpleCDCheck("Maul")
			-- end
			-- return nil
		-- end,
		-- ["FF_noFF"] = function()
			-- return lib.SimpleCDCheck("FF",lib.GetAuras("FF")-1)
		-- end,
	-- }
	
	-- lib.rangecheck=function()
		-- if lib.inrange("Mangle") then
			-- lib.bdcolor(Heddmain.bd,nil)
		-- elseif lib.inrange("FF") then
			-- lib.bdcolor(Heddmain.bd,{0,0,1,1})
		-- else
			-- lib.bdcolor(Heddmain.bd,{1,0,0,1})
		-- end
	-- end
	
	-- cfg.plist=cfg.plistdps
	-- cfg.mode = "dps"
	-- lib.onclick = function()
		-- if cfg.mode == "dps" then
			-- cfg.mode = "aoe"
			-- cfg.plist=cfg.plistaoe
			-- cfg.Update=true
		-- else
			-- cfg.mode = "dps"
			-- cfg.plist=cfg.plistdps
			-- cfg.Update=true
		-- end
		
	-- end
	
	-- cfg.spells_aoe={"Swipe"}
	-- cfg.spells_single={"FF"}
-- elseif cfg.shape=="Cat" then
	lib.AddSpell("Rake",{1822}) -- Rake
	lib.AddAura("Rake",155722,"debuff","target") -- Rake
	lib.SetTrackDOT("Rake")
	lib.AddSpell("Shred",{5221}) -- Shred
	lib.AddSpell("SR",{52610}) -- Savage Roar
	lib.AddAura("SR",52610,"buff","player") -- Savage Roar
	lib.AddSpell("Rip",{1079}) -- Rip
	lib.AddAura("Rip",1079,"debuff","target") -- Rip
	
	lib.AddSpell("FB",{22568}) -- Ferocious Bite
	lib.AddSpell("TF",{5217}) -- Tiger's Fury
	lib.AddAura("TF",5217,"buff","player") -- Tiger's Fury
	
	-- lib.AddSpell("Ravage",{6785}) -- Ravage
	-- lib.AddSpell("Ravage!",{81170},nil,true) -- Ravage!
	lib.AddSpell("Charge",{49376}) -- Feral Charge
	
	lib.AddSpell("Berserk",{106952}) -- Berserk
	lib.AddAura("Berserk",106951,"buff","player") -- Berserk
	-- lib.AddSpell("Mangle",{33876}) -- Mangle
	
	
	
	-- lib.AddSpell("Swipe",{62078}) -- Swipe
	-- lib.AddSpell("FF",{16857}) -- Faerie Fire (Feral)
	
--	lib.AddSpell("Ravage!",{81170}) -- Ravage!
	
	

	-- lib.AddAura("Stampede",81022,"buff","player") -- Stampede
	lib.AddAura("OoC",135700,"buff","player") -- Omen of Clarity
	lib.SetTrackAura("OoC")
	lib.SetAuraFunction("OoC","OnApply",function()
		lib.UpdateTrackAura(cfg.GUID["player"],0)
	end)
	lib.SetAuraFunction("OoC","OnFade",function()
		lib.UpdateTrackAura(cfg.GUID["player"])
	end)
	
	
	
	
	--lib.AddAuras("Mangle",{35290,57386,50271,16511,33876,33878,46857},"debuff","target") -- Mangle
	
	--lib.AddAuras("FF",{91565,95466,7386,8647,95467},"debuff","target") -- FF
	
	cfg.plistdps = {}
	table.insert(cfg.plistdps,"Berserk_TF")
	table.insert(cfg.plistdps,"TF")
	table.insert(cfg.plistdps,"SR_noSR")
	table.insert(cfg.plistdps,"FB_5_25")
	table.insert(cfg.plistdps,"Rip_noRip")
	table.insert(cfg.plistdps,"FB_5")
	table.insert(cfg.plistdps,"Rake_noRake")
	table.insert(cfg.plistdps,"Shred")
	table.insert(cfg.plistdps,"end")
	
	cfg.plistaoe = {}
	table.insert(cfg.plistaoe,"Rake_noRake")
	table.insert(cfg.plistaoe,"Shred")
	table.insert(cfg.plistaoe,"end")

	cfg.case = {
		["Rake_noRake"] = function()
			if cfg.AltPower.now==cfg.AltPower.max then return nil end
			return lib.SimpleCDCheck("Rake",lib.GetAura({"Rake"})-4.5)
		end,
		["Shred"] = function()
			if cfg.AltPower.now==cfg.AltPower.max then return nil end
			return lib.SimpleCDCheck("Shred")
		end,
		["SR_noSR"] = function()
			if cfg.AltPower.now>=1 then
				if lib.GetAura({"SR"})<lib.GetSpellCD("FB") then
					return lib.SimpleCDCheck("SR",lib.GetAura({"SR"}))
				else
					if cfg.AltPower.now>=5 then
						return lib.SimpleCDCheck("SR",lib.GetAura({"SR"})-12.6)
					end
				end
			end
			return nil
		end,
		["Rip_noRip"] = function()
			if cfg.AltPower.now==cfg.AltPower.max then
				return lib.SimpleCDCheck("Rip",lib.GetAura({"Rip"})-7.2)
			end
			return nil
		end,
		["FB_5"] = function()
			if cfg.AltPower.now==cfg.AltPower.max then
				if lib.Time2Power(50)>lib.GetAura({"Rip"})-7.2 then
					return nil
				else
					return lib.SimpleCDCheck("FB",lib.Time2Power(50))
				end
			end
			return nil
		end,
		["FB_5_25"] = function()
			if lib.GetUnitHealth("target","percent")>25 then return nil end
			if lib.GetAura({"Rip"})>lib.GetSpellCD("FB") then --cfg.AltPower.now==cfg.AltPower.max and
				if cfg.AltPower.now>=5 then
					return lib.SimpleCDCheck("FB",math.min(lib.Time2Power(50),lib.GetAura({"Rip"})-1))
				else
					return lib.SimpleCDCheck("FB",lib.GetAura({"Rip"})-1)
				end
			end
			
			return nil
		end,
		["TF"] = function()
			if (lib.Time2Power(40)-1.5)>lib.GetSpellCD("TF") and lib.GetAura({"OoC"})==0 then
				return lib.SimpleCDCheck("TF")
			end
			return nil
		end,
		["Berserk_TF"] = function()
			--return lib.SimpleCDCheck("Berserk")
			if lib.GetAura({"TF"})>lib.GetSpellCD("Berserk") then
				return lib.SimpleCDCheck("Berserk")
			end
			return nil
		end,
		
		
		["Ravage!"] = function()
			if lib.GetLastSpell({"Ravage!"}) then return nil end
			return lib.SimpleCDCheck("Ravage!")
		end,
		["Rake_aoe"] = function()
			if not lib.GetLastSpell({"Rake"}) and lib.GetAura({"SR"})<lib.GetSpellCD("Rake") then
				return lib.SimpleCDCheck("Rake",lib.GetAura({"Rake"}))
			end
			return nil
		end,
		
		
		["Swipe"] = function()
			return lib.SimpleCDCheck("Swipe")
			end,
		
		["SR"] = function()
			if cfg.AltPower.now>=1 and lib.GetAura({"Rip"})>0  then
				return lib.SimpleCDCheck("SR",lib.GetAura({"SR"}))
			end
			return nil
		end,
		["Shred_OoC"] = function()
			if lib.GetAura({"OoC"})>lib.GetSpellCD("Shred") then
				return lib.SimpleCDCheck("Shred")
			end
			return nil
		end,
--[[		["Rake"] = function()
			if not lib.GetLastSpell({"Rake"}) then
				if lib.GetAura({"TF"})>lib.GetSpellCD("Rake") then
					return lib.SimpleCDCheck("Rake",(lib.GetAura({"Rake"})-9))
				else
					return lib.SimpleCDCheck("Rake",(lib.GetAura({"Rake"})-2))
				end
			end
			return nil
		end,]]
		
		["FB_Berserk"] = function()
			if cfg.AltPower.now==5 and lib.GetAura({"Rip"})>(5+lib.GetSpellCD("FB")) and lib.GetAura({"SR"})>(3+lib.GetSpellCD("FB")) and lib.GetAura({"Berserk"})>lib.GetSpellCD("FB") then
				return lib.SimpleCDCheck("FB")
			end
			return nil
		end,
		["FB"] = function()
			if cfg.AltPower.now==5 and lib.GetAura({"Rip"})>=(14+lib.GetSpellCD("FB")) and lib.GetAura({"SR"})>=(10+lib.GetSpellCD("FB")) then
				return lib.SimpleCDCheck("FB")
			end
			return nil
		end,
		["FB_biw"] = function()
			if cfg.health<=cfg.bloodinwater and lib.GetAura({"Rip"})>lib.GetSpellCD("FB") then
				if cfg.AltPower.now==5 and lib.GetAura({"SR"})>lib.GetSpellCD("FB") then
					return lib.SimpleCDCheck("FB")
				elseif cfg.AltPower.now>0 then
					return lib.SimpleCDCheck("FB",lib.GetAura({"Rip"})-4)
				end
			end
			return nil
		end,
		["Rip"] = function()
			if cfg.AltPower.now==5 and (lib.GetAura({"Berserk"})>lib.GetSpellCD("Rip") or lib.GetAura({"Rip"})<=lib.GetSpellCD("TF")) then
				return lib.SimpleCDCheck("Rip",lib.GetAura({"Rip"})-2)
			end
			return nil
		end,
		["Shred_Rip"] = function()
			if lib.GetAura({"Rip"})>0 and cfg.health>25 then
				return lib.SimpleCDCheck("Shred",(lib.GetAura({"Rip"})-4))
			end
			return nil
		end,
		
		
		["Charge"] = function()
			if lib.inrange("Charge") then --and (not lib.inrange("Shred")) 
				return lib.SimpleCDCheck("Charge")
			end
			return nil
		end,
		["Charge_run"] = function()
			if lib.GetAura({"TF"})==0 and lib.GetAura({"Berserk"})==0 and lib.GetSpellCD("Charge")==lib.GetSpellCD("gcd") and cfg.Power.now>=lib.GetSpellCost("Charge") and cfg.Power.now<lib.GetSpellCost("Shred") then
				return lib.SimpleCDCheck("Charge")
			end
			return nil
		end,
		["Mangle_noMangle"] = function()
			if lib.GetLastSpell({"Mangle"}) then return nil end
			return lib.SimpleCDCheck("Mangle",lib.GetAuras("Mangle"))
		end,
		["FF_noFF"] = function()
			return lib.SimpleCDCheck("FF",lib.GetAuras("FF")-1)
		end,
	}

	lib.rangecheck=function()
		if lib.inrange("Shred") then
			lib.bdcolor(Heddmain.bd,nil)
		elseif lib.inrange("Charge") then
			lib.bdcolor(Heddmain.bd,{0,0,1,1})
		elseif lib.inrange("FF") then
			lib.bdcolor(Heddmain.bd,{0,1,0,1})
		else
			lib.bdcolor(Heddmain.bd,{1,0,0,1})
		end
	end
	
	cfg.plist=cfg.plistdps
	cfg.mode = "dps"
	lib.onclick = function()
		if cfg.mode == "dps" then
			cfg.mode = "aoe"
			cfg.plist=cfg.plistaoe
			cfg.Update=true
		else
			cfg.mode = "dps"
			cfg.plist=cfg.plistdps
			cfg.Update=true
		end
		
	end
	
	cfg.spells_aoe={"Swipe"}
	cfg.spells_single={"Shred"}
	
	lib.CD = function()
		lib.CDadd("Berserk",nil,true)
		lib.CDadd("TF",nil,true)
	end
return true
end

--[[lib.classevents["DRUID"] = function()
	lib.onshapeupdate = function()
		Heddtal_onevent()
	end
end]]
