-- get the addon namespace
local addon, ns = ...
-- get the config values
local cfg = ns.cfg
-- holder for some lib functions
local lib = _G["HEDD_lib"] or CreateFrame("Frame","HEDD_lib")
ns.lib = lib

lib.ComboAdd = function(num,pos,x,y,space,smooth)
	num = num or 5
	pos = pos or {"BOTTOM",Heddframe,"TOP",0,20}
	x=lib.realX(x or 5)
	y=lib.realY(y or 10)
	space = lib.realX(space or 2)
	smooth = smooth or {0,1,0, 1,1,0, 1,0,0}
	Heddframe.combo = Heddframe.combo or CreateFrame("Frame","$parent_Combo",f)
	--Heddframe.combo:SetScale(1 / UIParent:GetScale())
--	Heddframe.combo:Show()
	Heddframe.combo.max=num
	Heddframe.combo.num=0
	Heddframe.combo:SetHeight(y)
	Heddframe.combo:SetWidth((x+space)*num-space)
	Heddframe.combo:SetPoint(unpack(pos))
	Heddframe.combo.current=Heddframe.combo.current or {}
	Heddframe.combo.background=Heddframe.combo.background or {}
	for i=1, num do
		Heddframe.combo.background[i] = Heddframe.combo.background[i] or Heddframe.combo:CreateTexture("$parent_"..i, "BACKGROUND")
		Heddframe.combo.background[i]:SetHeight(y)
		Heddframe.combo.background[i]:SetWidth(x)
		Heddframe.combo.background[i]:SetTexture(cfg.statusbar_texture)
		Heddframe.combo.background[i]:SetPoint("BOTTOMLEFT",Heddframe.combo,"BOTTOMLEFT",(x+space)*(i-1),0)
		--Heddframe.combo.background[i]:SetVertexColor(hedlib.ColorGradient((i-1)/(num-1),unpack(smooth)))
		hedlib.SetDesaturation(Heddframe.combo.background[i],true)
		Heddframe.combo.background[i]:SetAlpha(0.3)
		Heddframe.combo.background[i]:Show()
		
		Heddframe.combo.current[i] = Heddframe.combo.current[i] or Heddframe.combo:CreateTexture("$parent_"..i, "OVERLAY")
		Heddframe.combo.current[i]:SetHeight(y)
		Heddframe.combo.current[i]:SetWidth(x)
		Heddframe.combo.current[i]:SetTexture(cfg.statusbar_texture)
		Heddframe.combo.current[i]:SetPoint("BOTTOMLEFT",Heddframe.combo,"BOTTOMLEFT",(x+space)*(i-1),0)
		Heddframe.combo.current[i]:SetVertexColor(hedlib.ColorGradient((i-1)/(num-1),unpack(smooth)))
		Heddframe.combo.current[i]:Hide()
	end
	lib.Hedd_slash("combo "..HeddDB.combo)
	--return Heddframe.combo
end

lib.ComboSet = function(num)
	if Heddframe.combo then
		Heddframe.combo.num=num
		for i=1,Heddframe.combo.max do
			if i<=num then
				Heddframe.combo.current[i]:Show()
			else
				Heddframe.combo.current[i]:Hide()
			end
		end
	end
end

lib.GetComboMax = function()
	if Heddframe.combo then
		return Heddframe.combo.max
	else
		return 0
	end
end

lib.GetComboNum = function()
	if Heddframe.combo then
		return Heddframe.combo.num
	else
		return 0
	end
end

lib.HideCombo = function()
	lib.HideFrame(Heddframe.combo)
	if not Heddframe.combo or not Heddframe.combo.current then return end
	i=1
	while true do
		if not Heddframe.combo.current[i] then
			return
		else
			Heddframe.combo.current[i]:Hide()
			Heddframe.combo.background[i]:Hide()
		end
		i=i+1
	end
end
